Attribute VB_Name = "mMain"
Option Explicit

Private Type pakheader_t
    magic       As String * 4
    diroffset   As Long
    dirsize     As Long
End Type

Private Type pakentry_t
    filename    As String * 56
    offset      As Long
    size   As Long
End Type

Public PakHeader As pakheader_t
Public PakEntry As pakentry_t
Public StoreEntry() As pakentry_t
Public PakFlag As Boolean

Private orig_filename As String

'    -  
Public Function IsPath(ByVal filename As String, Optional ByRef _
    newName As String) As Boolean

newName = RemoveStuff(filename)
If filename = "" Then IsPath = False: Exit Function
If InStr(1, filename, "/", vbBinaryCompare) <> 0 Then
    IsPath = True
End If

End Function

'     ""
Private Function RemoveStuff(ByRef filename As String) As String
    RemoveStuff = Left$(filename, InStr(1, filename, Chr(0)))
End Function

'     
Public Function GetPath(ByVal filename As String) As String
If IsPath(filename, filename) Then
    GetPath = Left$(filename, Len(filename) - Len(GetNam(filename)) - 1)
Else
    GetPath = ""
End If
End Function

'   
Public Function GetNam(ByVal filename As String, Optional ByVal cutEx As Boolean = False) As String
If Not cutEx Then
    GetNam = Right$(filename, InStrRev(filename, "/") - 1)
Else
    GetNam = Right$(filename, InStrRev(filename, "/") - 1)
    GetNam = Mid$(GetNam, 1, Len(GetNam) - InStrRev(GetNam, "."))
End If
End Function

'   
Public Function GetEx(ByVal filename As String) As String
    GetEx = Right$(filename, InStrRev(filename, "."))
End Function

Public Function InStrRev(ByVal str As String, ByVal match As _
    String, Optional ByVal start As Integer = 1) As Integer
    
Dim i As Integer, ii As Integer
ii = 1
For i = Len(str) - (start - 1) To 1 Step -1
    If Mid$(str, i, 1) = match Then
        InStrRev = ii: Exit Function
    End If
    ii = ii + 1
Next i
InStrRev = 0
End Function

' -  . ,    StoreEntry
Public Function OpenPAK(ByVal filename As String) As Boolean
Dim FFe As Integer, loopvar As Integer, curentry As Integer
Dim ReadString As String * 64
FFe = FreeFile
Open filename For Random As #FFe Len = Len(PakHeader)
Get #FFe, , PakHeader
Close #FFe
If PakHeader.magic <> "PACK" Then
    FFe = MsgBox("Invalid Pack File", vbOKOnly + vbInformation)
    OpenPAK = False
    Exit Function
End If

ReDim Preserve StoreEntry((PakHeader.dirsize / 64))
FFe = FreeFile
curentry = 1
Open filename For Binary As #FFe
Get #FFe, PakHeader.diroffset + 1, PakEntry
For loopvar = 1 To ((PakHeader.dirsize / 64))
    StoreEntry(curentry).filename = PakEntry.filename
    StoreEntry(curentry).offset = PakEntry.offset
    StoreEntry(curentry).size = PakEntry.size
    curentry = curentry + 1
    Get #FFe, , PakEntry
Next
Close #FFe
orig_filename = filename
OpenPAK = True
End Function

' -   . 
Public Function CreatePAK(ByVal filename As String) As Boolean
Dim FFe As Integer

FFe = FreeFile
PakHeader.magic = "PACK"
PakHeader.diroffset = 12
PakHeader.dirsize = 0

On Error GoTo err_h
If Dir(filename, vbNormal) <> "" Then Kill filename
Open filename For Binary As #FFe Len = Len(PakHeader)
    Put #FFe, , PakHeader
Close #FFe

CreatePAK = True
orig_filename = filename
Exit Function
err_h:
CreatePAK = False
End Function

'     .pak 
Sub ShowEntry(TV As TreeView)
  On Error Resume Next
  Dim TP2() As String
  Dim i&, j&
  Dim TMP$
  Dim ParentKey$

TV.Nodes.Add , tvwFirst, "ROOT", orig_filename, 3

  For i = 0 To UBound(StoreEntry)
    TMP = GetPath(StoreEntry(i).filename)
    If InStr(TMP, "/") > 0 Then
      TP2 = Split(TMP, "/")
      ParentKey = vbNullString
      TV.Nodes.Add "ROOT", tvwChild, TP2(0), TP2(0), 1, 2
      ParentKey = TP2(0)
      For j = 1 To UBound(TP2)
        TMP = TP2(j)
        TV.Nodes.Add ParentKey, tvwChild, ParentKey & TMP & "\", TMP, 1, 2
        ParentKey = ParentKey & TMP & "\"
      Next
    Else
      If TMP <> vbNullString Then TV.Nodes.Add "ROOT", tvwChild, TMP, TMP, 1, 2
    End If
  Next
End Sub

'        _

Public Sub ShowFilesEntry(ByVal path As String)
Dim i As Long, l As Long, TMP As String
fMain.List1.ListItems.Clear
If Len(path) <> Len(orig_filename) Then
    path = Right$(path, Len(path) - (Len(orig_filename) + 1))
    For i = LBound(StoreEntry) + 1 To UBound(StoreEntry)
    If InStr(1, StoreEntry(i).filename, path) <> 0 Then
        If Len(GetPath(RemoveStuff(StoreEntry(i).filename))) = Len(path) Then
            AddFile GetNam(StoreEntry(i).filename), _
            StoreEntry(i).size
        End If
    End If
    Next i
Else
    For i = LBound(StoreEntry) + 1 To UBound(StoreEntry)
    If InStr(1, RemoveStuff(StoreEntry(i).filename), "/") = 0 Then
            AddFile RemoveStuff((StoreEntry(i).filename)), _
            StoreEntry(i).size
    End If
    Next i
End If
End Sub

'           
Private Sub AddFile(ByVal file As String, ByVal size As Long)
    fMain.List1.ListItems.Add , , file
If size <= 1024 Then
    fMain.List1.ListItems(fMain.List1.ListItems.Count).ListSubItems.Add , , size & " b"
ElseIf size > 1024 Then
    fMain.List1.ListItems(fMain.List1.ListItems.Count).ListSubItems.Add , , size \ 1024 & " Kb"
End If
End Sub
